#!/bin/bash
if [ -z "$1" ]; then echo 'specify the mode of operation: 1 to dack or 2 to undack'; exit 666; fi
if [ "$1" = "1" ]; then
        if [ -z "$2" ]; then echo 'specify the filename to use without an extension. e.g. hello not hello.tgz'; exit 666; fi
        if [ -z "$3" ]; then echo 'specify the directory to archive'; exit 666; fi
        FNAME="$2"; FDIR="$3"; echo -e "\n[ dacking archive ]\n"
        tar cvfz $FNAME.tgz $FDIR && cat $FNAME.tgz|base64 > $FNAME.tgz.b64 && dd bs=128 count=3 if=/dev/random of=random > /dev/null 2>&1 && cat random|base64 > b64 && dd bs=77 count=2 if=b64 of=trash > /dev/null 2>&1 && cat $FNAME.tgz.b64 >> trash && mv trash $FNAME.tgz.b64.d && rm random && rm *b64 && rm $FNAME.tgz && FPASS=$(sha256sum $FNAME.tgz.b64.d|cut -c1-64) && zip $FNAME.zip $FNAME.tgz.b64.d -r9 -P $FPASS && rm -Rf $FDIR && rm $FNAME.tgz.b64.d && echo -e "\n\n[ your archive password is: $FPASS ]\n[ your passworded archive is: $FNAME.zip ]\n\n.[d]." && echo "[ passworded archive: $FNAME.zip ]\n[ archive password: $FPASS ]\n\n.[d]." > $FNAME.zip.password
elif [ "$1" = "2" ]; then
        if [ -z "$2" ]; then echo 'specify the filename to undack'; exit 666; fi
        FNAME="$2"
        if ! [ -f $FNAME ]; then echo "file does not exist"; exit 666; fi
        if [ -z "$3" ]; then echo 'specify the password for the packed file'; exit 666; fi
        FPASS="$3"; echo -e "\n[ undacking archive  ]\n"
        unzip -P $FPASS $FNAME && FNAMELESS=$(echo "$FNAME" | cut -f 1 -d '.')
        if [ $? -ne 0 ]; then echo "not ok: $?"; echo "error: problem undacking"; exit 666; fi
        dd skip=77 bs=2 if=$FNAMELESS.tgz.b64.d of=$FNAMELESS.tgz.b64 > /dev/null 2>&1
        if [ $? -ne 0 ]; then echo "not ok: $?"; echo "error: problem undacking"; exit 666; fi
        cat $FNAMELESS.tgz.b64|base64 -d > $FNAMELESS.tgz
        if [ $? -ne 0 ]; then echo "not ok: $?"; echo "error: problem undacking"; exit 666; fi
        tar zxvf $FNAMELESS.tgz
        if [ $? -ne 0 ]; then echo "not ok: $?"; echo "error: problem undacking"; exit 666; fi
        rm *.tgz.b64.d && rm *.tgz.b64 && rm $FNAMELESS.tgz
else echo 'usage error: e.g. bash d.sh 1 backup ~/Pictures'; exit 666; fi
